package com.nokia.finance.tasks.config;

import lombok.Data;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.context.annotation.Configuration;

@Configuration
@ConfigurationProperties("job.config")
@Data
public class JobConfig {
    /**
     * copy脚本路径
     */
    private String copyScriptPath;
    /**
     * 导入的数据库ip
     */
    private String dbHost;
    /**
     * 数据库端口
     */
    private String dbPort;
    /**
     * 数据库账号
     */
    private String dbUsername;
    /**
     * 数据库密码
     */
    private String dbPassword;
    /**
     * 数据库名称
     */
    private String dbName;
    /**
     * 睿行车辆基本信息日数据路径
     */
    private String carBaseDataDaySourcePath;
    /**
     * 睿行车辆基本信息日数据归档路径
     */
    private String carBaseDataDayHistoryPath;
    /**
     * 睿行车辆越界报警日数据路径
     */
    private String carYueJieSourcePath;
    /**
     * 睿行车辆越界报警日数据归档路径
     */
    private String carYueJieHistoryPath;
    /**
     * 睿行车辆报废月数据路径
     */
    private String carBaoFeiSourcePath;
    /**
     * 睿行车辆报废月数据归档路径
     */
    private String carBaoFeiHistoryPath;
    /**
     * 睿行车辆行驶里程月数据路径
     */
    private String carLiChengMonthSourcePath;
    /**
     * 睿行车辆行驶里程月数据归档路径
     */
    private String carLiChengMonthHistoryPath;
    /**
     * 睿行车辆行驶里程日数据路径
     */
    private String carLiChengDaySourcePath;
    /**
     * 睿行车辆行驶里程日数据归档路径
     */
    private String carLiChengDayHistoryPath;
    /**
     * 睿行车辆无单用车报警月统计数据路径
     */
    private String carWuDanYongCheSourcePath;
    /**
     * 睿行车辆无单用车报警月统计数据归档路径
     */
    private String carWuDanYongCheHistoryPath;
    /**
     * 睿行车辆用车月统计数据路径
     */
    private String carYongCheSourcePath;
    /**
     * 睿行车辆用车月统计数据归档路径
     */
    private String carYongCheHistoryPath;
    /**
     * 河北成本管理系统车辆燃油数据路径
     */
    private String carRanYouSourcePath;
    /**
     * 河北成本管理系统车辆燃油数据归档路径
     */
    private String carRanYouHistoryPath;
    /**
     * 河北成本管理系统车辆大额维修数据路径
     */
    private String carDaWeiXiuSourcePath;
    /**
     * 河北成本管理系统车辆大额维修数据归档路径
     */
    private String carDaWeiXiuHistoryPath;
    /**
     * 河北成本管理系统车辆普通维修数据路径
     */
    private String carWeiXiuSourcePath;
    /**
     * 河北成本管理系统车辆普通维修数据归档路径
     */
    private String carWeiXiuHistoryPath;
    /**
     * 河北成本管理系统车辆路桥数据路径
     */
    private String carLuQiaoSourcePath;
    /**
     * 河北成本管理系统车辆路桥数据归档路径
     */
    private String carLuQiaoHistoryPath;
    /**
     * 河北成本管理系统车辆保险数据路径
     */
    private String carBaoXianSourcePath;
    /**
     * 河北成本管理系统车辆保险数据归档路径
     */
    private String carBaoXianHistoryPath;
    /**
     * 河北成本管理系统车辆年检数据路径
     */
    private String carNianJianFeiSourcePath;
    /**
     * 河北成本管理系统车辆年检数据归档路径
     */
    private String carNianJianFeiHistoryPath;
    /**
     * 河北成本管理系统车辆其他费用数据路径
     */
    private String carQiTaSourcePath;
    /**
     * 河北成本管理系统车辆其他费用数据归档路径
     */
    private String carQiTaHistoryPath;
    /**
     * 河北成本管理系统私车公用数据路径
     */
    private String carSiCheGongYongSourcePath;
    /**
     * 河北成本管理系统私车公用数据归档路径
     */
    private String carSiCheGongYongHistoryPath;
    /**
     * 河北价值管理平台省内车辆费用月数据路径
     */
    private String carFeeHbSourcePath;
    /**
     * 河北价值管理平台省内车辆费用月数据归档路径
     */
    private String carFeeHbHistoryPath;
    /**
     * 河北价值管理平台北十车辆费用月数据路径
     */
    private String carFeeBsSourcePath;
    /**
     * 河北价值管理平台北十车辆费用月数据归档路径
     */
    private String carFeeBsHistoryPath;
    /**
     * 河北成本管理系统自有类房产维修数据路径
     */
    private String houseBuildingRepairMonthSourcePath;
    /**
     * 河北成本管理系统自有类房产维修数据归档路径
     */
    private String houseBuildingRepairMonthHistoryPath;
    /**
     * 河北成本管理系统不动产租赁房产维修数据路径
     */
    private String houseRentInRepairMonthSourcePath;
    /**
     * 河北成本管理系统不动产租赁房产维修数据归档路径
     */
    private String houseRentInRepairMonthHistoryPath;
    /**
     * 违规车辆策略输出路径
     */
    private String carWdyjOutputPath;
    /**
     * 高油耗车辆策略输出路径
     */
    private String carHighFuelConsumptionOutputPath;
    /**
     * 高修理车辆策略输出路径
     */
    private String carHighRepairOutputPath;
    /**
     * 车辆低效占比策略输出路径
     */
    private String carInefficiencyPercentOutputPath;
    /**
     * 车辆低效区县策略输出路径
     */
    private String carInefficiencyQxOutputPath;
    /**
     * 租赁车辆产生维修费策略输出路径
     */
    private String carRentalRepairOutputPath;
    /**
     * 车辆违章未处理策略输出路径
     */
    private String carViolationUnprocessedOutputPath;
    /**
     * 车效大屏建设数据输出路径
     */
    private String carCxdpOutputPath;
    /**
     * 房产大屏建筑面积统计输出路径
     */
    private String houseBuildingAreaStatOutputPath;
    /**
     * 房产大屏建筑和土地数量统计输出路径
     */
    private String houseBuildingLandCountOutputPath;
    /**
     * 房产大屏出租收入统计输出路径
     */
    private String houseRentalIncomeOutputPath;
    /**
     * 闲置建筑面积超过1000平米策略输出路径
     */
    private String houseBuildingIdleStrategyOutputPath;
    /**
     * 河北成本管理系统车辆服务费数据路径
     */
    private String carFuWuFeiSourcePath;
    /**
     * 河北成本管理系统车辆服务费数据归档路径
     */
    private String carFuWuFeiHistoryPath;
    /**
     * 策略输出临时路径
     */
    private String tempOutputDir;
}
