package com.nokia.finance.tasks.enums;

public enum JobEnum {
    /**
     * 睿行车辆基本信息日数据入库定时任务
     */
    CAR_BASE_DATA_DAY_JOB,
    /**
     * 睿行车辆越界报警日数据入库定时任务
     */
    CAR_YUE_JIE_JOB,
    /**
     * 睿行车辆报废月数据入库定时任务
     */
    CAR_BAO_FEI_JOB,
    /**
     * 睿行车辆行驶里程月数据入库定时任务
     */
    CAR_LI_CHENG_MONTH_JOB,
    /**
     * 睿行车辆无单用车报警月统计数据入库定时任务
     */
    CAR_WU_DAN_YONG_CHE_JOB,
    /**
     * 睿行车辆用车月统计数据入库定时任务
     */
    CAR_YONG_CHE_JOB,
    /**
     * 河北成本管理系统车辆燃油数据入库定时任务
     */
    CAR_RAN_YOU_JOB,
    /**
     * 河北成本管理系统车辆大额维修数据入库定时任务
     */
    CAR_DA_WEI_XIU_JOB,
    /**
     * 河北成本管理系统车辆普通维修数据入库定时任务
     */
    CAR_WEI_XIU_JOB,
    /**
     * 河北成本管理系统车辆路桥数据入库定时任务
     */
    CAR_LU_QIAO_JOB,
    /**
     * 河北成本管理系统车辆保险数据入库定时任务
     */
    CAR_BAO_XIAN_JOB,
    /**
     * 河北成本管理系统车辆年检数据入库定时任务
     */
    CAR_NIAN_JIAN_FEI_JOB,
    /**
     * 河北成本管理系统车辆其他费用数据入库定时任务
     */
    CAR_QI_TA_JOB,
    /**
     * 河北价值管理平台省内车辆费用月数据入库定时任务
     */
    CAR_FEE_HB_JOB,
    /**
     * 河北价值管理平台北十车辆费用月数据入库定时任务
     */
    CAR_FEE_BS_JOB,
    /**
     * 河北成本管理系统自有类房产维修数据入库定时任务
     */
    HOUSE_BUILDING_REPAIR_MONTH_JOB,
    /**
     * 河北成本管理系统车辆私车公用数据入库定时任务
     */
    CAR_SI_CHE_GONG_YONG_JOB,
    /**
     * 河北成本管理系统不动产租赁房产维修数据入库定时任务
     */
    HOUSE_RENT_IN_REPAIR_MONTH_JOB,
    /**
     * 河北成本管理系统车辆服务费数据入库定时任务
     */
    CAR_FU_WU_FEI_JOB,
    /**
     * 睿行车辆行驶里程日数据入库定时任务
     */
    CAR_LI_CHENG_DAY_JOB,
    /**
     * 车辆报告定时任务
     */
    CAR_REPORT_JOB,
    /**
     * 不动产报告定时任务
     */
    HOUSE_REPORT_JOB,
    /**
     * 车效大屏建设数据定时任务
     */
    CAR_CXDP_JOB,
    /**
     * 高油耗车辆策略定时任务
     */
    CAR_HIGH_FUEL_CONSUMPTION_JOB,
    /**
     * 高修理车辆策略定时任务
     */
    CAR_HIGH_REPAIR_JOB,
    /**
     * 车辆低效占比策略定时任务
     */
    CAR_INEFFICIENCY_PERCENT_JOB,
    /**
     * 车辆低效区县策略定时任务
     */
    CAR_INEFFICIENCY_QX_JOB,
    /**
     * 租赁车辆产生维修费策略定时任务
     */
    CAR_RENTAL_REPAIR_JOB,
    /**
     * 车辆违章未处理策略定时任务
     */
    CAR_VIOLATION_UNPROCESSED_JOB,
    /**
     * 违规车辆策略定时任务
     */
    CAR_WDYJ_JOB,
    /**
     * 闲置建筑面积超过1000平米策略定时任务
     */
    HOUSE_BUILDING_IDLE_STRATEGY_JOB,
    /**
     * 房产大屏建筑面积统计定时任务
     */
    HOUSE_BUILDING_AREA_STAT_JOB,
    /**
     * 房产大屏建筑和土地数量统计定时任务
     */
    HOUSE_BUILDING_LAND_COUNT_JOB,
    /**
     * 房产大屏出租收入统计定时任务
     */
    HOUSE_RENTAL_INCOME_JOB,
    ;
}
