//package com.nokia.finance.tasks.jobs.car.ruixing;
//
//import com.google.gson.Gson;
//import com.google.gson.reflect.TypeToken;
//import com.nokia.finance.tasks.common.exception.MyRuntimeException;
//import com.nokia.finance.tasks.common.utils.psql.PsqlUtil;
//import com.nokia.finance.tasks.config.JobConfig;
//import com.nokia.finance.tasks.pojo.po.common.AreaPo;
//import com.nokia.finance.tasks.pojo.po.common.OrganizationPo;
//import com.nokia.finance.tasks.service.car.CarService;
//import com.nokia.finance.tasks.service.common.AreaService;
//import com.nokia.finance.tasks.service.common.OrganizationService;
//import lombok.extern.slf4j.Slf4j;
//import org.apache.commons.csv.CSVFormat;
//import org.apache.commons.csv.CSVPrinter;
//import org.apache.poi.ss.usermodel.Cell;
//import org.apache.poi.ss.usermodel.DateUtil;
//import org.apache.poi.ss.usermodel.Row;
//import org.apache.poi.ss.usermodel.Sheet;
//import org.apache.poi.ss.usermodel.Workbook;
//import org.apache.poi.xssf.usermodel.XSSFWorkbook;
//import org.springframework.stereotype.Service;
//import org.springframework.util.CollectionUtils;
//
//import java.io.InputStream;
//import java.io.OutputStreamWriter;
//import java.nio.charset.StandardCharsets;
//import java.nio.file.Files;
//import java.nio.file.Path;
//import java.nio.file.Paths;
//import java.nio.file.StandardCopyOption;
//import java.time.LocalDate;
//import java.time.format.DateTimeFormatter;
//import java.util.ArrayList;
//import java.util.LinkedHashMap;
//import java.util.List;
//import java.util.Map;
//import java.util.concurrent.CompletableFuture;
//import java.util.concurrent.TimeUnit;
//import java.util.regex.Matcher;
//import java.util.regex.Pattern;
//import java.util.stream.Stream;
//
///**
// * 睿行车辆用车信息总览月数据入库定时任务
// */
//@Slf4j
//@Service
//public class CarYongCheZongLanJob {
//    private final JobConfig jobConfig;
//    private final CarService carService;
//    private final OrganizationService organizationService;
//    private final AreaService areaService;
//
//    public CarYongCheZongLanJob(JobConfig jobConfig, CarService carService, OrganizationService organizationService,
//                                AreaService areaService) {
//        this.jobConfig = jobConfig;
//        this.carService = carService;
//        this.organizationService = organizationService;
//        this.areaService = areaService;
//    }
//
//    /**
//     * 执行任务
//     */
////    @Scheduled(cron = "0 58 5 1 * ?")
//    public void runJob() {
//        // 数据目录
//        Path dir = Paths.get(jobConfig.getCarYongCheZongLanSourcePath());
//        try (Stream<Path> stream = Files.list(dir)) {
//            // 获取数据目录下的文件列表
//            List<Path> pathList = stream.filter(t -> t.toString().endsWith(".xlsx")).sorted().toList();
//            log.info("睿行车辆用车信息总览月数据文件列表: {}", pathList);
//            if (CollectionUtils.isEmpty(pathList)) {
//                throw new MyRuntimeException("睿行车辆用车信息总览月数据没有文件");
//            }
//            for (Path path : pathList) {
//                CompletableFuture.runAsync(() -> {
//                    try {
//                        singleJob(path);
//                    } catch (Exception e) {
//                        throw new MyRuntimeException(e);
//                    }
//                }).get(5, TimeUnit.MINUTES);
//            }
//        } catch (InterruptedException e) {
//            log.error("线程中断: {}", e.toString(), e);
//            Thread.currentThread().interrupt();
//        } catch (Exception e) {
//            log.error(e.toString(), e);
//        }
//    }
//
//    /**
//     * 处理单个文件
//     *
//     * @param path 文件路径
//     */
//    public void singleJob(Path path) throws Exception {
//        if (Files.size(path) == 0) {
//            move(path);
//            throw new MyRuntimeException(path.getFileName() + " 空文件");
//        }
//        List<Map<String, String>> list = readFile(path);
////        List<Map<String, String>> distinctList = dataProcessing(path, list);
////        Path csvPath = toCsv(path, distinctList);
//        Path csvPath = toCsv(path, list);
////        copyCsv(csvPath);
////        move(path);
//    }
//
//    /**
//     * 读取文件
//     *
//     * @param path 文件路径
//     */
//    public List<Map<String, String>> readFile(Path path) throws Exception {
//        log.info("读取: {}", path);
//        try (InputStream inputStream = Files.newInputStream(path);
//             Workbook workbook = new XSSFWorkbook(inputStream)
//        ) {
//            List<Map<String, String>> resultList = new ArrayList<>();
//            // 读取第一个工作表
//            Sheet sheet = workbook.getSheetAt(0);
//            // 最后行数
//            int lastRowNum = sheet.getLastRowNum();
//            log.info("lastRowNum: {}", lastRowNum);
//            if (lastRowNum == 0) {
//                throw new MyRuntimeException(path.getFileName() + " 数据0条");
//            }
//            Gson gson = new Gson();
//            int currentRowNum = 0;
//            while (currentRowNum <= lastRowNum) {
//                log.info(">>>>>>>>>>currentRowNum: {}", currentRowNum);
//                Map<String, String> rowMap = new LinkedHashMap<>();
//                // 申请单表头行
//                Row row1 = sheet.getRow(currentRowNum);
//                // 申请单数据行
//                Row row2 = sheet.getRow(++currentRowNum);
//                if (currentRowNum > lastRowNum) {
//                    break;
//                }
//                List<String> headers1;
//                int lastCellNum1 = row1.getLastCellNum();
//                headers1 = switch (lastCellNum1) {
//                    case 9 ->
//                            Stream.of("shen_qing_dan_hao", "shen_qing_ren", "shen_qing_ren_dan_wei", "shen_qing_lei_xing", "yong_che_ren", "yong_che_ren_dan_wei", "yong_che_shi_you", "shen_qing_dan_zhuang_tai", "shen_qing_shi_jian").toList();
//                    case 13 ->
//                            Stream.of("shen_qing_dan_hao", "shen_qing_ren", "shen_qing_ren_dan_wei", "shen_qing_lei_xing", "yong_che_ren", "yong_che_ren_dan_wei", "yong_che_shi_you", "shen_qing_dan_zhuang_tai", "shen_pi_ren1", "shen_pi_jie_guo1", "shen_pi_shi_jian1", "shen_pi_yi_jian1", "shen_qing_shi_jian").toList();
//                    case 17 ->
//                            Stream.of("shen_qing_dan_hao", "shen_qing_ren", "shen_qing_ren_dan_wei", "shen_qing_lei_xing", "yong_che_ren", "yong_che_ren_dan_wei", "yong_che_shi_you", "shen_qing_dan_zhuang_tai", "shen_pi_ren1", "shen_pi_jie_guo1", "shen_pi_shi_jian1", "shen_pi_yi_jian1", "shen_pi_ren2", "shen_pi_jie_guo2", "shen_pi_shi_jian2", "shen_pi_yi_jian2", "shen_qing_shi_jian").toList();
//                    default ->
//                            Stream.of("shen_qing_dan_hao", "shen_qing_ren", "shen_qing_ren_dan_wei", "shen_qing_lei_xing", "yong_che_ren", "yong_che_ren_dan_wei", "yong_che_shi_you", "shen_qing_dan_zhuang_tai", "shen_pi_ren1", "shen_pi_jie_guo1", "shen_pi_shi_jian1", "shen_pi_yi_jian1", "shen_pi_ren2", "shen_pi_jie_guo2", "shen_pi_shi_jian2", "shen_pi_yi_jian2", "shen_pi_ren3", "shen_pi_jie_guo3", "shen_pi_shi_jian3", "shen_pi_yi_jian3", "shen_qing_shi_jian").toList();
//                };
//
//                int headerSize1 = headers1.size();
//                for (int i = 0; i < headerSize1; i++) {
//                    String header = headers1.get(i);
//                    Cell cell = row2.getCell(i);
//                    String cellValue = "";
//                    switch (cell.getCellType()) {
//                        case STRING:
//                            boolean skipTrim = "shen_qing_shi_jian".equals(header)
//                                    || "shen_pi_shi_jian1".equals(header)
//                                    || "shen_pi_shi_jian2".equals(header)
//                                    || "shen_pi_shi_jian3".equals(header);
//                            // 删除字符串空白字符
//                            cellValue = skipTrim ? cell.getStringCellValue()
//                                    : org.springframework.util.StringUtils.trimAllWhitespace(cell.getStringCellValue());
//                            break;
//                        case NUMERIC:
//                            if (DateUtil.isCellDateFormatted(cell)) {
//                                cellValue = DateUtil.getLocalDateTime(cell.getNumericCellValue())
//                                        .format(DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss"));
//                                break;
//                            }
//                            cellValue = String.valueOf(cell.getNumericCellValue());
//                            break;
//                        case BOOLEAN:
//                            cellValue = String.valueOf(cell.getBooleanCellValue());
//                            break;
//                        default:
//                            break;
//                    }
//                    rowMap.put(header, cellValue);
//                }
//                ++currentRowNum;
//                if (currentRowNum > lastRowNum) {
//                    resultList.add(rowMap);
//                    break;
//                }
//                if (!"派遣单编号".equals(sheet.getRow(currentRowNum).getCell(0).getStringCellValue())) {
//                    resultList.add(rowMap);
//                    continue;
//                }
//
//                while (currentRowNum <= lastRowNum) {
//                    Map<String, String> rowMapCopy = gson.fromJson(gson.toJson(rowMap), new TypeToken<>() {});
//                    // 派遣单表头行
//                    Row row3 = sheet.getRow(currentRowNum);
//                    if (!"派遣单编号".equals(row3.getCell(0).getStringCellValue())) {
//                        break;
//                    }
//                    Row row4 = sheet.getRow(++currentRowNum);
//                    if (currentRowNum > lastRowNum) {
//                        break;
//                    }
//                    List<String> headers2 = Stream.of("pai_qian_dan_bian_hao", "che_pai_hao", "jia_shi_yuan", "chu_che_shi_jian", "gui_dui_shi_jian", "pai_qian_che_liang_zhuang_tai", "ren_wu_zhi_xing_zhuang_tai").toList();
//                    int headersSize2 = headers2.size();
//                    for (int i = 0; i < headersSize2; i++) {
//                        String header = headers2.get(i);
//                        Cell cell = row4.getCell(i);
//                        String cellValue = "";
//                        switch (cell.getCellType()) {
//                            case STRING:
//                                boolean skipTrim = "chu_che_shi_jian".equals(header)
//                                        || "gui_dui_shi_jian".equals(header);
//                                // 删除字符串空白字符
//                                cellValue = skipTrim ? cell.getStringCellValue()
//                                        : org.springframework.util.StringUtils.trimAllWhitespace(cell.getStringCellValue());
//                                break;
//                            case NUMERIC:
//                                if (DateUtil.isCellDateFormatted(cell)) {
//                                    cellValue = DateUtil.getLocalDateTime(cell.getNumericCellValue())
//                                            .format(DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss"));
//                                    break;
//                                }
//                                cellValue = String.valueOf(cell.getNumericCellValue());
//                                break;
//                            case BOOLEAN:
//                                cellValue = String.valueOf(cell.getBooleanCellValue());
//                                break;
//                            default:
//                                break;
//                        }
//                        rowMapCopy.put(header, cellValue);
//                    }
//                    resultList.add(rowMapCopy);
//                    currentRowNum++;
//                }
//            }
//            return resultList;
//        }
//    }
//
//    /**
//     * 数据加工
//     *
//     * @param path 文件路径
//     * @param list 数据
//     */
//    public List<Map<String, String>> dataProcessing(Path path, List<Map<String, String>> list) {
//        // 从文件名提取日期
//        String regex = "\\d{6}";
//        Pattern pattern = Pattern.compile(regex);
//        Matcher matcher = pattern.matcher(path.getFileName().toString());
//        String dateString;
//        if (matcher.find()) {
//            dateString = matcher.group() + "01";
//        } else {
//            throw new MyRuntimeException(path.getFileName() + " 提取日期失败");
//        }
//        LocalDate localDate = LocalDate.parse(dateString, DateTimeFormatter.ofPattern("yyyyMMdd"));
//        String yearMonth = localDate.format(DateTimeFormatter.ofPattern("yyyyMM"));
//        String year = String.valueOf(localDate.getYear());
//        String month = String.valueOf(localDate.getMonthValue());
//        List<OrganizationPo> secondOrgs = organizationService.getSecondOrgs();
//        List<OrganizationPo> thirdOrgs = organizationService.getThirdOrgs();
//        Map<String, OrganizationPo> orgMap = organizationService.getOrgMap(secondOrgs, thirdOrgs);
//        Map<String, List<OrganizationPo>> thirdOrganizationListMap =
//                organizationService.getThirdOrganizationListMap(secondOrgs, thirdOrgs);
//        List<AreaPo> cities = areaService.getCities();
//        List<AreaPo> districts = areaService.getDistricts();
//        Map<String, AreaPo> areaMap = areaService.getAreaMap(cities, districts);
//        Map<String, List<AreaPo>> districtListMap = areaService.getDistrictListMap(cities, districts);
//        for (Map<String, String> map : list) {
//            map.put("year_month", yearMonth);
//            map.put("year_no", year);
//            map.put("month_no", month);
//            String rawChePaiHao = map.get("che_pai_hao");
//            map.put("raw_che_pai_hao", rawChePaiHao);
//            String chePaiHao = carService.getChePai(rawChePaiHao);
//            map.put("che_pai_hao", chePaiHao);
//            String chePaiFail = carService.chePaiFail(rawChePaiHao);
//            map.put("che_pai_fail", chePaiFail);
//            String yongCheBuMen = map.get("yong_che_bu_men");
//            String firstUnit = carService.getFirstUnit(yongCheBuMen);
//            map.put("first_unit", firstUnit);
//            String secondUnit = carService.getSecondUnit(yongCheBuMen, firstUnit);
//            map.put("second_unit", secondUnit);
//            String thirdUnit = carService.getThirdUnit(yongCheBuMen, secondUnit);
//            map.put("third_unit", thirdUnit);
//            String areaNo = carService.getAreaNo(secondOrgs, yongCheBuMen);
//            map.put("area_no", areaNo);
//            String areaName = carService.getOrgName(orgMap, areaNo);
//            map.put("area_name", areaName);
//            String cityNo = carService.getCityNo(thirdOrganizationListMap, areaNo, areaName, yongCheBuMen);
//            map.put("city_no", cityNo);
//            String cityName = carService.getOrgName(orgMap, cityNo);
//            map.put("city_name", cityName);
//            String areaNo2 = carService.getAreaNo2(areaName, cityName);
//            map.put("area_no2", areaNo2);
//            String areaName2 = carService.getOrgName(orgMap, areaNo2);
//            map.put("area_name2", areaName2);
//            String cityId = carService.getCityId(cities, yongCheBuMen);
//            map.put("city_id", cityId);
//            String city = carService.getAreaName(areaMap, cityId);
//            map.put("city", city);
//            String districtId = carService.getDistrictId(districtListMap, cityId, cityName, yongCheBuMen);
//            map.put("district_id", districtId);
//            String district = carService.getAreaName(areaMap, districtId);
//            map.put("district", district);
//            String baoFei = carService.baoFei(rawChePaiHao);
//            map.put("bao_fei", baoFei);
//            map.put("source", path.getFileName().toString());
//        }
//        return list;
//    }
//
//    /**
//     * 生成csv
//     *
//     * @param path 源文件路径
//     * @param list 数据
//     */
//    public Path toCsv(Path path, List<Map<String, String>> list) throws Exception {
//        log.info("条数：{}", list.size());
//        Files.createDirectories(Paths.get(jobConfig.getCarYongCheZongLanHistoryPath()));
//        Path csvPath = Paths.get(jobConfig.getCarYongCheZongLanHistoryPath() + path.getFileName() + ".csv");
//        try (OutputStreamWriter osw = new OutputStreamWriter(Files.newOutputStream(csvPath),
//                StandardCharsets.UTF_8);
//             CSVPrinter printer = new CSVPrinter(osw, CSVFormat.DEFAULT)) {
//            // 添加bom头避免excel乱码
//            osw.write('\ufeff');
//            // 表头
////            printer.printRecord("shen_qing_dan_hao", "shen_qing_ren", "shen_qing_ren_dan_wei", "shen_qing_lei_xing", "yong_che_ren", "yong_che_ren_dan_wei", "yong_che_shi_you", "shen_qing_dan_zhuang_tai", "shen_qing_shi_jian", "shen_pi_ren1", "shen_pi_jie_guo1", "shen_pi_shi_jian1", "shen_pi_yi_jian1", "shen_pi_ren2", "shen_pi_jie_guo2", "shen_pi_shi_jian2", "shen_pi_yi_jian2", "shen_pi_ren3", "shen_pi_jie_guo3", "shen_pi_shi_jian3", "shen_pi_yi_jian3", "pai_qian_dan_bian_hao", "che_pai_hao", "jia_shi_yuan", "chu_che_shi_jian", "gui_dui_shi_jian", "pai_qian_che_liang_zhuang_tai", "ren_wu_zhi_xing_zhuang_tai");
//            printer.printRecord("申请单号","申请人","申请人单位","申请类型","用车人","用车人单位","用车事由","申请单状态","申请时间","审批人1","审批结果1","审批时间1","审批意见1","审批人2","审批结果2","审批时间2","审批意见2","审批人3","审批结果3","审批时间3","审批意见3","派遣单编号","车牌号码","驾驶员","出车时间","归队时间","派遣车辆状态","任务执行状态");
//            for (Map<String, String> map : list) {
//                printer.printRecord(
//                        map.get("shen_qing_dan_hao"),
//                        map.get("shen_qing_ren"),
//                        map.get("shen_qing_ren_dan_wei"),
//                        map.get("shen_qing_lei_xing"),
//                        map.get("yong_che_ren"),
//                        map.get("yong_che_ren_dan_wei"),
//                        map.get("yong_che_shi_you"),
//                        map.get("shen_qing_dan_zhuang_tai"),
//                        map.get("shen_qing_shi_jian"),
//                        map.get("shen_pi_ren1"),
//                        map.get("shen_pi_jie_guo1"),
//                        map.get("shen_pi_shi_jian1"),
//                        map.get("shen_pi_yi_jian1"),
//                        map.get("shen_pi_ren2"),
//                        map.get("shen_pi_jie_guo2"),
//                        map.get("shen_pi_shi_jian2"),
//                        map.get("shen_pi_yi_jian2"),
//                        map.get("shen_pi_ren3"),
//                        map.get("shen_pi_jie_guo3"),
//                        map.get("shen_pi_shi_jian3"),
//                        map.get("shen_pi_yi_jian3"),
//                        map.get("pai_qian_dan_bian_hao"),
//                        map.get("che_pai_hao"),
//                        map.get("jia_shi_yuan"),
//                        map.get("chu_che_shi_jian"),
//                        map.get("gui_dui_shi_jian"),
//                        map.get("pai_qian_che_liang_zhuang_tai"),
//                        map.get("ren_wu_zhi_xing_zhuang_tai")
//                );
//            }
//        }
//        return csvPath;
//    }
//
//    /**
//     * 导入数据库
//     *
//     * @param path 文件路径
//     */
//    public void copyCsv(Path path) {
//        String dbTable = "car.car_yong_che_zong_lan";
//        String csv = path.toString();
//        String columns = "(shen_qing_dan_hao,pai_qian_dan_hao,shen_qing_lei_xing,che_pai_hao,che_liang_lei_xing,che_liang_ji_bie,si_ji_ming_cheng,yong_che_ren,yong_che_bu_men,yong_che_shi_you,chu_fa_di,mu_di_di,chu_fa_shi_jian,gui_dui_shi_jian,xing_shi_li_cheng,chu_che_shi_chang,year_month,year_no,month_no,raw_che_pai_hao,che_pai_fail,first_unit,second_unit,third_unit,area_no,area_name,city_no,city_name,area_no2,area_name2,city_id,city,district_id,district,bao_fei,source)";
//        Long timeout = 60000L;
//        PsqlUtil.copyCsv(jobConfig.getCopyScriptPath(), jobConfig.getDbHost(), jobConfig.getDbPort(),
//                jobConfig.getDbUsername(), jobConfig.getDbPassword(), jobConfig.getDbName(), dbTable, csv, columns,
//                timeout, null);
//    }
//
//    /**
//     * 移动源文件到历史文件夹
//     *
//     * @param path 源文件路径
//     */
//    public void move(Path path) throws Exception {
//        Path targetPath = Paths.get(jobConfig.getCarYongCheZongLanHistoryPath(), path.getFileName().toString());
//        Files.move(path, targetPath, StandardCopyOption.REPLACE_EXISTING);
//    }
//}
