package com.nokia.finance.tasks.pojo.po.house_report;

import lombok.Data;

import java.math.BigDecimal;

@Data
public class HouseBuildingIdleStrategyPo {
    /**
     * 数据年月
     */
    private Integer yearMonth;

    /**
     * 建筑ID
     */
    private String buildingId;

    /**
     * 资产所属单位(一级)
     */
    private String firstUnit;

    /**
     * 资产所属单位(二级)
     */
    private String secondUnit;

    /**
     * 资产所属单位(三级)
     */
    private String thirdUnit;

    /**
     * 局址编号
     */
    private String siteNum;

    /**
     * 局址别名
     */
    private String siteName;

    /**
     * 标准地址
     */
    private String address;

    /**
     * 城市等级
     */
    private String cityLevel;

    /**
     * 城市区域
     */
    private String cityRegion;

    /**
     * 地段
     */
    private String areaSector;

    /**
     * 是否有土地资产
     */
    private String hasLand;

    /**
     * 局址ID
     */
    private String siteId;

    /**
     * 建筑别名
     */
    private String buildingName;

    /**
     * 得房率
     */
    private BigDecimal housingAcquisitionRate;

    /**
     * 房屋来源
     */
    private String housingSource;

    /**
     * 取得日期
     */
    private String acquisitionDate;

    /**
     * 房龄开始年份
     */
    private Integer houseYearBegan;

    /**
     * 投资主体
     */
    private String investor;

    /**
     * 管理层级
     */
    private String managementLevel;

    /**
     * 房屋结构
     */
    private String buildingStructure;

    /**
     * 楼层总数
     */
    private String totalFloors;

    /**
     * 资产编号
     */
    private String assetsNum;

    /**
     * 资产标签号
     */
    private String assetsTagNum;

    /**
     * 使用状态
     */
    private String usageStatus;

    /**
     * 建筑用途
     */
    private String buildingUse;

    /**
     * 权属状态
     */
    private String ownershipStatus;

    /**
     * 建筑占地面积(㎡)
     */
    private BigDecimal floorArea;

    /**
     * 建筑面积(㎡)
     */
    private BigDecimal buildingArea;

    /**
     * 建筑面积-自用(㎡)
     */
    private BigDecimal buildingAreaSelfUse;

    /**
     * 建筑面积-出租(㎡)
     */
    private BigDecimal buildingAreaRent;

    /**
     * 建筑面积-闲置(㎡)
     */
    private BigDecimal buildingAreaIdle;

    /**
     * 建筑面积-不可使用(㎡)
     */
    private BigDecimal buildingAreaUnusable;

    /**
     * 使用面积(㎡)
     */
    private BigDecimal usableArea;

    /**
     * 使用面积-自用(㎡)
     */
    private BigDecimal usableAreaSelfUse;

    /**
     * 使用面积-出租(㎡)
     */
    private BigDecimal usableAreaRent;

    /**
     * 使用面积-闲置(㎡)
     */
    private BigDecimal usableAreaIdle;

    /**
     * 使用面积-不可使用(㎡)
     */
    private BigDecimal usableAreaUnusable;

    /**
     * 地市
     */
    private String city;

    /**
     * 区县
     */
    private String district;

    /**
     * 经度wgs84
     */
    private BigDecimal lngWgs84;

    /**
     * 纬度wgs84
     */
    private BigDecimal latWgs84;

    /**
     * 经度bd09
     */
    private BigDecimal lngBd09;

    /**
     * 纬度bd09
     */
    private BigDecimal latBd09;

    /**
     * 建筑图片
     */
    private String buildingImg;

    /**
     * 二级组织机构编码
     */
    private String areaNo;

    /**
     * 二级组织机构名称
     */
    private String areaName;

    /**
     * 三级组织机构编码
     */
    private String cityNo;

    /**
     * 三级组织机构名称
     */
    private String cityName;

    /**
     * 年
     */
    private Integer yearNo;

    /**
     * 月
     */
    private Integer monthNo;

    /**
     * 房龄
     */
    private Integer houseAge;

    /**
     * 上级土地名称
     */
    private String landName;

    /**
     * 是否临街
     */
    private String frontage;

    /**
     * 是否有院落
     */
    private String courtyard;

    /**
     * 整栋是否独有
     */
    private String wholeBuilding;

    /**
     * 是否有房产证
     */
    private String propertyOwnershipCertificate;

    /**
     * 无房产证原因
     */
    private String noPropertyOwnershipCertificateReason;

    /**
     * 未关联资产
     */
    private String unrelatedAssets;

    /**
     * 楼长姓名
     */
    private String communityAssistantName;

    /**
     * 楼长单位
     */
    private String communityAssistantUnit;

    /**
     * 经度集团
     */
    private BigDecimal lngJt;

    /**
     * 纬度集团
     */
    private BigDecimal latJt;

    /**
     * 实际产权人
     */
    private String propertyOwner;

    /**
     * 是否完成清查
     */
    private String checked;

    /**
     * 地市id
     */
    private String cityId;

    /**
     * 区县id
     */
    private String districtId;
}
