package com.nokia.finance.tasks.pojo.vo.house_report;

import com.nokia.finance.tasks.pojo.po.house_report.HouseRentOutIncomeStatPo;
import lombok.Data;

import java.text.DecimalFormat;

@Data
public class HouseCzsrTableVo {
    /**
     * 二级组织机构名称
     */
    private String areaName;

    /**
     * 本年累计出租收入万元合计
     */
    private String incomeAll;

    /**
     * 本年出租收入预算万元合计
     */
    private String budgetAll;

    /**
     * 预算完成率
     */
    private String budgetFinishRate;

    /**
     * 上年同期累计出租收入万元合计
     */
    private String lastYearIncomeAll;

    /**
     * 较上年同期增减额万元
     */
    private String yoy;

    /**
     * 同比百分比
     */
    private String yoyPercent;

    /**
     * 收入贡献率
     */
    private String contributionRate;

    /**
     * 预算完成排名
     */
    private String budgetFinishRank;

    /**
     * 增幅排名
     */
    private String increaseAmplitudeRank;

    public HouseCzsrTableVo(String areaName) {
        this.areaName = areaName;
        this.incomeAll = "";
        this.budgetAll = "";
        this.budgetFinishRate = "";
        this.lastYearIncomeAll = "";
        this.yoy = "";
        this.yoyPercent = "";
        this.contributionRate = "";
        this.budgetFinishRank = "";
        this.increaseAmplitudeRank = "";
    }

    public void  update(HouseRentOutIncomeStatPo po) {
        DecimalFormat numberFormat = new DecimalFormat("#,##0.00");
        DecimalFormat integerFormat = new DecimalFormat("#,###");
        DecimalFormat percentFormat = new DecimalFormat("0.0%");
        this.incomeAll = numberFormat.format(po.getIncomeAll());
        this.budgetAll = integerFormat.format(po.getBudgetAll());
        this.budgetFinishRate = percentFormat.format(po.getBudgetFinishRate());
        this.lastYearIncomeAll = numberFormat.format(po.getLastYearIncomeAll());
        this.yoy = numberFormat.format(po.getYoy());
        this.yoyPercent = percentFormat.format(po.getYoyPercent());
        this.contributionRate = percentFormat.format(po.getContributionRate());
        this.budgetFinishRank = po.getBudgetFinishRank() == null ? "" : integerFormat.format(po.getBudgetFinishRank());
        this.increaseAmplitudeRank = po.getIncreaseAmplitudeRank() == null ? ""
                : integerFormat.format(po.getIncreaseAmplitudeRank());
    }
}
