package com.nokia.finance.tasks.pojo.vo.house_report;

import com.nokia.finance.tasks.pojo.po.house_report.HouseBuildingStatPo;
import lombok.Data;

import java.text.DecimalFormat;

@Data
public class HouseFczyztsyxlTableVo {
    /**
     * 二级组织机构名称
     */
    private String areaName;
    /**
     * 总面积
     */
    private String zmj;
    /**
     * 自用面积
     */
    private String zymj;
    /**
     * 出租面积
     */
    private String czmj;
    /**
     * 闲置面积
     */
    private String xzmj;
    /**
     * 闲置率
     */
    private String xzl;

    public HouseFczyztsyxlTableVo(HouseBuildingStatPo po) {
        DecimalFormat integerFormat = new DecimalFormat("#,###");
        DecimalFormat percentFormat = new DecimalFormat("0.00%");
        this.areaName = po.getAreaName();
        this.zmj = integerFormat.format(po.getZmj());
        this.zymj = integerFormat.format(po.getZymj());
        this.czmj = integerFormat.format(po.getCzmj());
        this.xzmj = integerFormat.format(po.getXzmj());
        this.xzl = percentFormat.format(po.getXzl());
    }

    public HouseFczyztsyxlTableVo(String areaName) {
        this.areaName = areaName;
        this.zmj = "";
        this.zymj = "";
        this.czmj = "";
        this.xzmj = "";
        this.xzl = "";
    }
}
