package com.nokia.finance.tasks.pojo.vo.house_report;

import com.nokia.finance.tasks.pojo.po.house_report.HouseBuildingIdleStrategyPo;
import lombok.Data;

import java.text.DecimalFormat;

@Data
public class HouseFwxzjzmjjkclTableVo {
    /**
     * 二级组织机构名称
     */
    private String areaName;

    /**
     * 三级组织机构名称
     */
    private String cityName;

    /**
     * 建筑别名
     */
    private String buildingName;

    /**
     * 房龄开始年份
     */
    private String houseYearBegan;

    /**
     * 地段
     */
    private String areaSector;

    /**
     * 使用状态
     */
    private String usageStatus;

    /**
     * 建筑用途
     */
    private String buildingUse;

    /**
     * 建筑面积(㎡)
     */
    private String buildingArea;

    /**
     * 建筑面积-自用(㎡)
     */
    private String buildingAreaSelfUse;

    /**
     * 建筑面积-出租(㎡)
     */
    private String buildingAreaRent;

    /**
     * 建筑面积-闲置(㎡)
     */
    private String buildingAreaIdle;

    /**
     * 建筑面积-不可使用(㎡)
     */
    private String buildingAreaUnusable;

    public HouseFwxzjzmjjkclTableVo() {
        this.areaName = "";
        this.cityName = "";
        this.buildingName = "";
        this.houseYearBegan = "";
        this.areaSector = "";
        this.usageStatus = "";
        this.buildingUse = "";
        this.buildingArea = "";
        this.buildingAreaSelfUse = "";
        this.buildingAreaRent = "";
        this.buildingAreaIdle = "";
        this.buildingAreaUnusable = "";
    }

    public HouseFwxzjzmjjkclTableVo(HouseBuildingIdleStrategyPo po) {
        DecimalFormat integerFormat = new DecimalFormat("#,###");
        this.areaName = po.getAreaName();
        this.cityName = po.getCityName();
        this.buildingName = po.getBuildingName();
        this.houseYearBegan = po.getHouseYearBegan() == null ? "" : String.valueOf(po.getHouseYearBegan());
        this.areaSector = po.getAreaSector();
        this.usageStatus = po.getUsageStatus();
        this.buildingUse = po.getBuildingUse();
        this.buildingArea = po.getBuildingArea() == null ? "" : integerFormat.format(po.getBuildingArea());
        this.buildingAreaSelfUse = po.getBuildingAreaSelfUse() == null ? ""
                : integerFormat.format(po.getBuildingAreaSelfUse());
        this.buildingAreaRent = po.getBuildingAreaRent() == null ? "" : integerFormat.format(po.getBuildingAreaRent());
        this.buildingAreaIdle = po.getBuildingAreaIdle() == null ? "" : integerFormat.format(po.getBuildingAreaIdle());
        this.buildingAreaUnusable = po.getBuildingAreaUnusable() == null ? ""
                : integerFormat.format(po.getBuildingAreaUnusable());
    }
}
