package com.nokia.finance.tasks.pojo.vo.house_report;

import com.nokia.finance.tasks.pojo.po.house_report.HouseBuildingIdleStrategyPo;
import lombok.Data;
import org.springframework.util.CollectionUtils;

import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.LinkedHashSet;
import java.util.List;
import java.util.Set;

@Data
public class HouseFwxzjzmjjkclVo {
    /**
     * 全省超1000平米闲置房产数量
     */
    private String qsxz;
    /**
     * 闲置房产所处核心商圈的单位
     */
    private String hxsqUnit;
    /**
     * 表格
     */
    private List<HouseFwxzjzmjjkclTableVo> table;

    public HouseFwxzjzmjjkclVo(List<HouseBuildingIdleStrategyPo> list) {
        this.table = new ArrayList<>();
        if (CollectionUtils.isEmpty(list)) {
            this.qsxz = "0";
            this.hxsqUnit = "无";
            this.table.add(new HouseFwxzjzmjjkclTableVo());
            return;
        }
        DecimalFormat integerFormat = new DecimalFormat("#,###");
        this.qsxz = integerFormat.format(list.size());
        Set<String> set = new LinkedHashSet<>();
        for (HouseBuildingIdleStrategyPo t : list) {
            this.table.add(new HouseFwxzjzmjjkclTableVo(t));
            if ("核心商圈".equals(t.getAreaSector())) {
                set.add(t.getAreaName());
            }
        }
        if (CollectionUtils.isEmpty(set)) {
            this.hxsqUnit = "无";
        } else {
            this.hxsqUnit = String.join("、", set);
        }
    }
}
