package com.nokia.finance.tasks.pojo.vo.house_report;

import com.nokia.finance.tasks.pojo.po.house_report.HouseBuildingSameRepairFrequencyPo;
import lombok.Data;

import java.text.DecimalFormat;

@Data
public class HouseGpwxjkclTableVo {
    /**
     * 二级组织机构名称
     */
    private String areaName;

    /**
     * 建筑别名
     */
    private String buildingName;

    /**
     * 维修类型
     */
    private String repairType;

    /**
     * 账期
     */
    private String yearMonth;

    /**
     * 本年累计维修频次
     */
    private String tyTotal;

    /**
     * 本年累计维修频次排名
     */
    private String tyTotalRank;

    public HouseGpwxjkclTableVo() {
        this.areaName = "";
        this.buildingName = "";
        this.repairType = "";
        this.yearMonth = "";
        this.tyTotal = "";
        this.tyTotalRank = "";
    }

    public HouseGpwxjkclTableVo(HouseBuildingSameRepairFrequencyPo po) {
        DecimalFormat integerFormat = new DecimalFormat("#,###");
        this.areaName = po.getAreaName();
        this.buildingName = po.getBuildingName();
        this.repairType = po.getRepairType();
        this.yearMonth = String.valueOf(po.getYearMonth());
        this.tyTotal = integerFormat.format(po.getTyTotal());
        this.tyTotalRank = integerFormat.format(po.getTyTotalRank());
    }
}
