package com.nokia.finance.tasks.utils;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.attribute.PosixFilePermission;
import java.util.Set;
import java.util.stream.Collectors;
import java.util.stream.Stream;

public class FileUtil {
    static final Set<PosixFilePermission> DEFAULT_DIR_PERMISSIONS = Stream.of(
            PosixFilePermission.OWNER_READ,
            PosixFilePermission.OWNER_WRITE,
            PosixFilePermission.OWNER_EXECUTE,
            PosixFilePermission.GROUP_READ,
            PosixFilePermission.GROUP_WRITE,
            PosixFilePermission.GROUP_EXECUTE,
            PosixFilePermission.OTHERS_READ,
            PosixFilePermission.OTHERS_EXECUTE
    ).collect(Collectors.toSet());

    static final Set<PosixFilePermission> DEFAULT_FILE_PERMISSIONS = Stream.of(
            PosixFilePermission.OWNER_READ,
            PosixFilePermission.OWNER_WRITE,
            PosixFilePermission.GROUP_READ,
            PosixFilePermission.GROUP_WRITE,
            PosixFilePermission.OTHERS_READ
    ).collect(Collectors.toSet());

    public static void setDefaultDirPermissions(Path path) throws IOException {
        Files.setPosixFilePermissions(path, DEFAULT_DIR_PERMISSIONS);
    }

    public static void setDefaultFilePermissions(Path path) throws IOException {
        Files.setPosixFilePermissions(path, DEFAULT_FILE_PERMISSIONS);
    }
}
